#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "html.h"
#include "attr.h"

struct _attrlist attrList[] =
{
    {"abbr",             VERS_HTML40},
    {"accept-charset",   VERS_HTML40},
    {"accept",           VERS_ALL},
    {"accesskey",        VERS_HTML40},
    {"action",           VERS_ALL},
    {"add_date",         VERS_NETSCAPE},
    {"align",            VERS_ALL},
    {"alink",            VERS_LOOSE},
    {"alt",              VERS_ALL},
    {"archive",          VERS_HTML40},
    {"axis",             VERS_HTML40},
    {"background",       VERS_LOOSE},
    {"bgcolor",          VERS_LOOSE},
    {"bgproperties",     VERS_PROPRIETARY},
    {"border",           VERS_ALL},
    {"bordercolor",      VERS_MICROSOFT},
    {"bottommargin",     VERS_MICROSOFT},
    {"cellpadding",      VERS_FROM32},
    {"cellspacing",      VERS_FROM32},
    {"char",             VERS_HTML40},
    {"charoff",          VERS_HTML40},
    {"charset",          VERS_HTML40},
    {"checked",          VERS_ALL},
    {"cite",             VERS_HTML40},
    {"class",            VERS_HTML40},
    {"classid",          VERS_HTML40},
    {"clear",            VERS_LOOSE},
    {"code",             VERS_LOOSE},
    {"codebase",         VERS_HTML40},
    {"codetype",         VERS_HTML40},
    {"color",            VERS_LOOSE},
    {"cols",             VERS_IFRAMES},
    {"colspan",          VERS_FROM32},
    {"compact",          VERS_ALL},
    {"content",          VERS_ALL},
    {"coords",           VERS_FROM32},
    {"data",             VERS_HTML40},
    {"datafld",          VERS_MICROSOFT},
    {"dataformatas",    VERS_MICROSOFT},
    {"datapagesize",     VERS_MICROSOFT},
    {"datasrc",          VERS_MICROSOFT},
    {"datetime",         VERS_HTML40},
    {"declare",          VERS_HTML40},
    {"defer",            VERS_HTML40},
    {"dir",              VERS_HTML40},
    {"disabled",         VERS_HTML40},
    {"enctype",          VERS_ALL},
    {"face",             VERS_LOOSE},
    {"for",              VERS_HTML40},
    {"frame",            VERS_HTML40},
    {"frameborder",      VERS_FRAMES},
    {"framespacing",     VERS_PROPRIETARY},
    {"gridx",            VERS_PROPRIETARY},
    {"gridy",            VERS_PROPRIETARY},
    {"headers",          VERS_HTML40},
    {"height",           VERS_ALL},
    {"href",             VERS_ALL},
    {"hreflang",         VERS_HTML40},
    {"hspace",           VERS_ALL},
    {"http-equiv",       VERS_ALL},
    {"id",               VERS_HTML40},
    {"ismap",            VERS_ALL},
    {"label",            VERS_HTML40},
    {"lang",             VERS_HTML40},
    {"language",         VERS_LOOSE},
    {"last_modified",    VERS_NETSCAPE},
    {"last_visit",       VERS_NETSCAPE},
    {"leftmargin",       VERS_MICROSOFT},
    {"link",             VERS_LOOSE},
    {"longdesc",         VERS_HTML40},
    {"lowsrc",           VERS_PROPRIETARY},
    {"marginheight",     VERS_IFRAMES},
    {"marginwidth",      VERS_IFRAMES},
    {"maxlength",        VERS_ALL},
    {"media",            VERS_HTML40},
    {"method",           VERS_ALL},
    {"multiple",         VERS_ALL},
    {"name",             VERS_ALL},
    {"nohref",           VERS_FROM32},
    {"noresize",         VERS_FRAMES},
    {"noshade",          VERS_LOOSE},
    {"nowrap",           VERS_LOOSE},
    {"object",           VERS_HTML40_LOOSE},
    {"onblur",           VERS_HTML40},
    {"onchange",         VERS_HTML40},
    {"onclick",          VERS_HTML40},
    {"ondblclick",       VERS_HTML40},
    {"onkeydown",        VERS_HTML40},
    {"onkeypress",       VERS_HTML40},
    {"onkeyup",          VERS_HTML40},
    {"onload",           VERS_HTML40},
    {"onmousedown",      VERS_HTML40},
    {"onmousemove",      VERS_HTML40},
    {"onmouseout",       VERS_HTML40},
    {"onmouseover",      VERS_HTML40},
    {"onmouseup",        VERS_HTML40},
    {"onsubmit",         VERS_HTML40},
    {"onreset",          VERS_HTML40},
     {"onselect",         VERS_HTML40},
    {"onunload",         VERS_HTML40},
    {"onafterupdate",    VERS_MICROSOFT},
    {"onbeforeupdate",   VERS_MICROSOFT},
    {"onerrorupdate",    VERS_MICROSOFT},
    {"onrowenter",       VERS_MICROSOFT},
    {"onrowexit",        VERS_MICROSOFT},
    {"onbeforeunload",   VERS_MICROSOFT},
    {"ondatasetchanged", VERS_MICROSOFT},
    {"ondataavailable",  VERS_MICROSOFT},
    {"ondatasetcomplete",VERS_MICROSOFT},
    {"profile",          VERS_HTML40},
    {"prompt",           VERS_LOOSE},
    {"readonly",         VERS_HTML40},
    {"rel",              VERS_ALL},
    {"rev",              VERS_ALL},
    {"rightmargin",      VERS_MICROSOFT},
    {"rows",             VERS_ALL},
    {"rowspan",          VERS_ALL},
    {"rules",            VERS_HTML40},
    {"scheme",           VERS_HTML40},
    {"scope",            VERS_HTML40},
    {"scrolling",        VERS_IFRAMES},
    {"selected",         VERS_ALL},
    {"shape",            VERS_FROM32},
    {"showgrid",         VERS_PROPRIETARY},
    {"showgridx",        VERS_PROPRIETARY},
    {"showgridy",        VERS_PROPRIETARY},
    {"size",             VERS_LOOSE},
    {"span",             VERS_HTML40},
    {"src",              (VERS_ALL|VERS_FRAMES)},
    {"standby",          VERS_HTML40},
    {"start",            VERS_ALL},
    {"style",            VERS_HTML40},
    {"summary",          VERS_HTML40},
    {"tabindex",         VERS_HTML40},
    {"target",           VERS_HTML40},
    {"text",             VERS_LOOSE},
    {"title",            VERS_HTML40},
    {"topmargin",        VERS_MICROSOFT},
    {"type",             VERS_FROM32},
    {"usemap",           VERS_ALL},
    {"valign",           VERS_FROM32},
    {"value",            VERS_ALL},
    {"valuetype",        VERS_HTML40},
    {"version",          VERS_ALL},
    {"vlink",            VERS_LOOSE},
    {"vspace",           VERS_LOOSE},
    {"width",            VERS_ALL},
    {"wrap",             VERS_NETSCAPE},
    {"xml:lang",         VERS_XML},
    {"xmlns",            VERS_ALL},
    /* this must be the final entry */
    {NULL,               0}
};



