#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "stack.h"
#include "mylib.h"

#define SUCCESS 0
#define NO_FILE 1
#define FILE_NOT_FOUND 2
#define FILE_NOT_HTML 3


int main(int argc, char *argv[])
{
	FILE *testFile, *log;
	
	log = fopen("marco.log", "a+");
	
	//system("echo \"################### Start of new log ###################\" >> marco.log");
	//system("date >> marco.log");
	
	if(argc <= 1)
	{
		fprintf(stderr,"Error... no file to test\n");
		fprintf(stderr,"usage: marco <file1> [file2 file3 ...]\n");
		fprintf(log, ">>>PANIC<<<Run with no input file specified\n");
		fclose(log);
		exit(NO_FILE);
	}
	
	{
		int i;
		for(i = 1; i < argc ; i++) 
		{ 
			int test[10];

			memset(test, 0x0, 10*sizeof(int));
			testFile = fopen(argv[i], "r");
			if(!testFile) 
			{
				fprintf(stderr,"Error: %s, file not found.\n", argv[i]);
				fprintf(log,">>>WORRY<<< File %s was not found. Check path and try again.\n", argv[i]);
				continue;
			}
			
			if(!isHtml(testFile))
			{
				fprintf(stderr,"Error: %s, not a HTML file.\n", argv[i]);
				fprintf(log,">>>WORRY<<< File %s, not a HTML file... skipping file.\n", argv[i]);
				continue;
			}
			
			fprintf(log,"Validating file %s.\n", argv[i]);
			printf("Validating file %s...", argv[i]);
			validateFile(testFile, test, log);
			printResult(test, log);
			printf("done\n");
		}
	}
	printf("Please check \"marco.log\" for the results of the validation\n");
	print_footer();
	fclose(log);
	
	return 0;
}
