#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "html.h"
#include "attr.h"
#include "tags.h"
#include "parser.h"
#include "stack.h"
#include "mylib.h"

void print_footer()
{
	printf("\n");
	printf("*************************************************************************\n");
	printf("*  Thank you for using MARCO. For comments/suggestions please contact:  *\n");
	printf("*  {sri,gvijay} at cs.umd.edu                                           *\n");
	printf("*  Written by Vijay and Sri, December 2001.                             *\n");
	printf("*************************************************************************\n");
}

void print_jscript(FILE *log)
{
fprintf(log, "Marco has detected the use of Javascript. It is advised you keep the\n");
fprintf(log, "   following in mind and check the scripts:\n");
fprintf(log, "\t# The fonts on the page will not be as you wanted on Netscape on\n");
fprintf(log, "\t  Linux and Solaris.\n");
fprintf(log, "\t# Correctness of the page when the user has disabled Javascipt. The\n");
fprintf(log, "\t  features in the page may not work correctly.\n");
fprintf(log, "\t# Re-direction when the user has diabled Javascript. Wrong scripts\n");
fprintf(log, "\t  may be a security loophole.\n");
}

void print_css(FILE *log)
{

}

void print_java(FILE *log)
{
fprintf(log, "Marco has detected the use of Java and has the following recommendations\n");
fprintf(log, "\t# Check to see if Java is enabled on the client browser. Otherwise,\n");
fprintf(log, "\t  the browser will not display anything, leaving the user clueless.\n");
}

void print_font(FILE *log)
{
fprintf(log, "Marco has detected the use of FONTS tag with SIZE as an attibute.\n");
fprintf(log, "   The size specified by you is an abstract size. Each browser \n");
fprintf(log, "   renders the same abtract size differently. So the page looks\n");
fprintf(log, "   different on each browser. We advice you to use Style sheets\n");
fprintf(log, "   instead.\n");
}

void print_image(FILE *log)
{
fprintf(log, "Marco has detected the use of IMG tag without ALT attibute. This\n");
fprintf(log, "   could create accesibility problems if the user has disabled\n");
fprintf(log, "   getting images. Some browsers, however, do not do a good job\n");
fprintf(log, "   of diplaying ALT text! We also do not recommend having links\n");
fprintf(log, "   using images due to the above reason\n");
}

void print_table(FILE *log)
{

}

void printResult(int test[], FILE *log)
{
	int i, cnt;
	
	fprintf(log, "\n####################################################\n");
	fprintf(log, "\t\t\tSummary of the tests\n");
	fprintf(log, "\t\t\t********************\n");

	if(test[0] == 1)
	{
		fprintf(log, "\n1. MARCO has detected the use of one(or more) of the following\n");
		fprintf(log, "   kinds of tags\n");
		fprintf(log, "\t# LOOSE tags\n");
		fprintf(log, "\t# Proprietary tags\n");
		fprintf(log, "\t# Unknown tags\n");
		fprintf(log, "   Such tags can cause difference in the display on differnt browsers.\n");
	}

	if(test[1] == 1)
	{
		fprintf(log, "\n2. MARCO has detected the presence of unmatched tags. Some\n");
		fprintf(log, "   browsers may be lenient on these, while some may not be.\n");
		fprintf(log,"\n\t&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\n");
		fprintf(log,"\t>>>WARNING<<<\n");
		fprintf(log,"\tYou may be getting the error because you do not\n");
		fprintf(log,"\topen and close the tags in the correct order\n");
		fprintf(log,"\t\te.g. You have <FONT><B>...</FONT></B>\n");
		fprintf(log,"\t&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&\n");
	}

	for( i = 2, cnt = 3; i < SIZE; i++)
	{
		if(test[i] == 1)
		{
			fprintf(log, "\n%d. ", cnt++);
			switch(i)
			{
			case JSCRIPT: 
				print_jscript(log);
				break;
			case CSS:
				print_css(log);
				break;
			case JAVA:
				print_java(log);
				break;
			case FONT:
				print_font(log);
				break;
			case IMAGE:
				print_image(log);
				break;
			case TABLE:
				print_table(log);
				break;
			}
		}
	}
	fprintf(log, "\n####################################################\n");
}

int isDigit(char ch)  //operands are single digits
{
	return ((ch >= '0') && (ch <= '9'));
}

int isOperator(char ch)
{
	return ((ch == '^') || (ch == '*') || (ch == '/') || (ch == '%') || 
		(ch == '+') || (ch == '-'));
}

int precedence(char op)
{
	if (op == '^')
		return 3;
	else if ((op =='*') || (op == '/') || (op == '%'))
		return 2;
	else
		return 1;
}

void stripSpace(char *buf, int len)
{
	char *temp = (char*) malloc(len * sizeof(char));
	if(!temp) {
		fprintf(stderr,"Unable to allocate memory... quitting\n");
		exit(99);
	}
	memset(temp, 0x0, len);
	{
		int i = 0, j = 0;
		while(buf[i] != '\0') {
			if(!isspace((int)buf[i]))
				temp[j++] = buf[i];
			i++;
		}
	}
	strcpy(buf, temp);
	free(temp);
}

int isHtml(FILE *testFile)
{
	char *buf;
	int flag = 0;
	
	buf = (char*) malloc(512 * sizeof(char));
	fread(buf, sizeof(char), 511, testFile);
	buf[511] = '\0';
	stripSpace(buf, strlen(buf)+1);
	
	if ((strstr(buf, "DOCTYPE") != 0) ||(strstr(buf, "doctype") != 0)) 
		flag = 1;
	if ((strstr(buf, "<html") != 0) ||(strstr(buf, "<HTML") != 0)) 
		flag = 1;
	if((strstr(buf, "<head") != 0) ||(strstr(buf, "<HEAD") != 0)) 
		flag = 1;
	if((strstr(buf, "<body") != 0) ||(strstr(buf, "<BODY") != 0)) 
		flag = 1;
	
	free(buf);
	rewind(testFile);
	if(flag == 1)
		return 1;
	else
		return 0;
}

void validateFile(FILE *testFile, int *test, FILE *log)
{
	int numTags, i = 0;
	tagDetails *tagdet;
	
	char ** tags = getTags(testFile, &numTags, log); 
	tagdet = (tagDetails*)malloc(numTags*sizeof(tagDetails));
	
	while(i < numTags)
    {
		parseTags(tags[i],&tagdet[i]);
		i++;
    }

	fprintf(log, "\nChecking for unavailable/proprietary tags...\n");	
	test[0] = checkTags(tagdet, numTags, log);
	fprintf(log, "Checking for unavailable/proprietary tags... done\n");	

	fprintf(log, "\nChecking for unmatched opening tags...\n");
	test[1] = checkClosing(tagdet,numTags, log);
	fprintf(log, "Checking for unmatched opening tags... done\n");

	fprintf(log, "\nChecking for existence of potential problems...\n");
	checkProbs(tagdet, numTags, test, log);
	fprintf(log, "Checking for existence of potential problems... done\n");
	
	for(i = 0; i < numTags; i++)
	{
		delAttr(&tagdet[i]);
		free(tags[i]);
	}
	free(tags);
	free(tagdet);
	
	return;
}

